/*********************************************************************
 *
 *                Microchip USB C18 Firmware Version 1.0
 *
 *********************************************************************
 * FileName:        eeprom.c
 * Processor:       PIC18
 ********************************************************************/

/** I N C L U D E S **********************************************************/
#include "p18f2550.h"
#include "typedefs.h"

/** D E C L A R A T I O N S **************************************************/
#pragma code


/******************************************************************************
 * Function:  Lecture data eeprom
 *****************************************************************************/
unsigned char RdEEPROM(unsigned char ad) {
	EEADR=ad;
	_asm
	 bcf	EECON1,7,0			// clear EEPGD
	 bcf	EECON1,6,0			// clear CFGS
	 bsf	EECON1,0,0			// set RD
	_endasm
	return(EEDATA);
	}

/******************************************************************************
 * Proc:  Ecriture data eeprom
 *****************************************************************************/
void WrEEPROM(unsigned char ad, unsigned char dat) {
 EEADR=ad;
 EEDATA=dat;

 // Stoppe toutes les Its !
 INTCONbits.GIE = 0;

 _asm
   bcf	EECON1,7,0			// clear EEPGD
   bcf	EECON1,6,0			// clear CFGS
   bsf	EECON1,2,0			// set WREN
   movlw	0x55
   movwf	EECON2,0
   movlw	0xAA
   movwf	EECON2,0

   bsf		EECON1,1,0			// set WR
waitwr:
   btfsc	EECON1,1,0
   bra 		waitwr
   bcf		EECON1,2,0			// raz WREN
 _endasm

 // Remet les Its !
 INTCONbits.GIE = 1;

}

/*****************************************************************************/
